package ru.alphatech.icfpc.game.strategy;

import java.util.ArrayList;
import java.util.LinkedList;

import ru.alphatech.icfpc.cards.I;
import ru.alphatech.icfpc.game.Batch;
import ru.alphatech.icfpc.game.ICFPCException;
import ru.alphatech.icfpc.game.Player;
import ru.alphatech.icfpc.game.Run;
import ru.alphatech.icfpc.game.Batch.OperationType;
import ru.alphatech.icfpc.policy.AttackHelpDelayPolicy;
import ru.alphatech.icfpc.policy.AttackHelpPolicy;
import ru.alphatech.icfpc.policy.CallExpressionPolicy;
import ru.alphatech.icfpc.policy.SetSlotValuePolicy;
import ru.alphatech.icfpc.policy.AttackHelpPolicy.TYPE;

public class LenarStrategy implements IStrategy{

	protected ArrayList<Batch> firstVitalityBoost(){
		ArrayList<Batch> rtArr = new ArrayList<Batch>();
		
//		rtArr.addAll(new AttackHelpPolicy(TYPE.HELP, 5, 8,   4, 6530, true).getBatches());
		rtArr.addAll(new AttackHelpPolicy(TYPE.HELP, 5, 16,  4, 6530).getBatches());
		rtArr.addAll(new AttackHelpPolicy(TYPE.HELP, 5, 32,  4, 6530).getBatches());
		rtArr.addAll(new AttackHelpPolicy(TYPE.HELP, 5, 64,  4, 6530).getBatches());
		rtArr.addAll(new AttackHelpPolicy(TYPE.HELP, 5, 128, 4, 6530).getBatches());
		
		rtArr.addAll(new SetSlotValuePolicy(3, 36000).getBatches());
		rtArr.addAll(new AttackHelpDelayPolicy(TYPE.HELP, 8, 4, 4, 3).getBatches());
		
		for(int i=0; i<16; ++i){
			rtArr.addAll(new CallExpressionPolicy(6, 8, 0, true).getBatches());
		}
		// 4.v = 65535
		
//		rtArr.addAll(new AttackHelpPolicy(TYPE.HELP, 8, 4, 4, 50000, false, 3).getBatches());
		rtArr.addAll(new SetSlotValuePolicy(3, 50000).getBatches());
		
		rtArr.addAll(new AttackHelpPolicy(TYPE.HELP, 5, 4, 16, 5000).getBatches());
		rtArr.addAll(new CallExpressionPolicy(6, 8, 0, true).getBatches());
		rtArr.addAll(new CallExpressionPolicy(6, 8, 0, true).getBatches());
		
		rtArr.addAll(new AttackHelpPolicy(TYPE.HELP, 5, 4, 32, 5000).getBatches());
		rtArr.addAll(new CallExpressionPolicy(6, 8, 0, true).getBatches());
		rtArr.addAll(new CallExpressionPolicy(6, 8, 0, true).getBatches());
		
		rtArr.addAll(new AttackHelpPolicy(TYPE.HELP, 5, 4, 64,  5000).getBatches());
		rtArr.addAll(new CallExpressionPolicy(6, 8, 0, true).getBatches());
		rtArr.addAll(new CallExpressionPolicy(6, 8, 0, true).getBatches());
		
		rtArr.addAll(new AttackHelpPolicy(TYPE.HELP, 5, 4, 128, 5000).getBatches());
		rtArr.addAll(new CallExpressionPolicy(6, 8, 0, true).getBatches());
		rtArr.addAll(new CallExpressionPolicy(6, 8, 0, true).getBatches());
		rtArr.addAll(new CallExpressionPolicy(6, 8, 0, true).getBatches());
		rtArr.addAll(new CallExpressionPolicy(6, 8, 0, true).getBatches());
		
		rtArr.addAll(new AttackHelpPolicy(TYPE.HELP, 9, 4, 0, 50000).getBatches());
		rtArr.addAll(new AttackHelpPolicy(TYPE.HELP, 9, 0, 4, 50000).getBatches());
		
		rtArr.addAll(new AttackHelpPolicy(TYPE.HELP, 9, 4, 1, 50000).getBatches());
		rtArr.addAll(new AttackHelpPolicy(TYPE.HELP, 9, 1, 4, 50000).getBatches());
		
		rtArr.addAll(new AttackHelpPolicy(TYPE.HELP, 9, 4, 2, 50000).getBatches());
		rtArr.addAll(new AttackHelpPolicy(TYPE.HELP, 9, 2, 4, 50000).getBatches());
		
		rtArr.addAll(new AttackHelpPolicy(TYPE.HELP, 9, 4, 3, 50000).getBatches());
		rtArr.addAll(new AttackHelpPolicy(TYPE.HELP, 9, 3, 4, 50000).getBatches());
		
		return rtArr;
	}
	
	LinkedList<Batch> batches = new LinkedList<Batch>();
	
	ArrayList<Batch> attackBatches(int targetSlot){
		
		ArrayList<Batch> rtArr = new ArrayList<Batch>();
		
		rtArr.addAll(new AttackHelpPolicy(TYPE.ATTACK, 7, 4, 255-i, 5000).getBatches());
		
		rtArr.addAll(new CallExpressionPolicy(6, 8, 0, true).getBatches());
		rtArr.addAll(new CallExpressionPolicy(6, 8, 0, true).getBatches());
		rtArr.addAll(new CallExpressionPolicy(6, 8, 0, true).getBatches());
		rtArr.addAll(new CallExpressionPolicy(6, 8, 0, true).getBatches());

		rtArr.addAll(new AttackHelpPolicy(TYPE.ATTACK, 7, 4, 255 - i, 5000)
				.getBatches());

		rtArr.addAll(new CallExpressionPolicy(6, 8, 0, true).getBatches());
		rtArr.addAll(new CallExpressionPolicy(6, 8, 0, true).getBatches());
		rtArr.addAll(new CallExpressionPolicy(6, 8, 0, true).getBatches());
		rtArr.addAll(new CallExpressionPolicy(6, 8, 0, true).getBatches());

		rtArr.addAll(new AttackHelpPolicy(TYPE.ATTACK, 7, 4, 255 - i, 5000)
				.getBatches());

		rtArr.addAll(new CallExpressionPolicy(6, 8, 0, true).getBatches());
		rtArr.addAll(new CallExpressionPolicy(6, 8, 0, true).getBatches());
		rtArr.addAll(new CallExpressionPolicy(6, 8, 0, true).getBatches());
		rtArr.addAll(new CallExpressionPolicy(6, 8, 0, true).getBatches());

		rtArr.addAll(new AttackHelpPolicy(TYPE.ATTACK, 7, 4, 255 - i, 5000)
				.getBatches());

		rtArr.addAll(new CallExpressionPolicy(6, 8, 0, true).getBatches());
		rtArr.addAll(new CallExpressionPolicy(6, 8, 0, true).getBatches());
		rtArr.addAll(new CallExpressionPolicy(6, 8, 0, true).getBatches());
		rtArr.addAll(new CallExpressionPolicy(6, 8, 0, true).getBatches());
		
		return rtArr;
	}
	
	public LenarStrategy() {
		batches.addAll(firstVitalityBoost());
		batches.addAll(attackBatches(0));
	}
	
	int i=0;
	
	@Override
	public Batch move(Player proponent, Player opponent) {
		Batch batch = batches.poll();
		if(batch != null)
			return batch;
		else{
			if( i > 255)
				return new Batch(OperationType.CARD_TO_SLOT, new I(), proponent.getSlot(0));
			
			batches.addAll( attackBatches(i) );
			++i;
			return batches.poll();
		}
	}

}
